#include "typedef.h"
#include "pwm.h"
#include "cap.h"
#include "adc.h"
#include "timer.h"
#include "uart.h"
#include "PID.h"


#define UART_STOP_FLAG 200
#define UART_START_FLAG 201
#define UART_POSI_FLAG 202
#define UART_MEG_FLAG 203


#define DRV_EN_Dir PAT2
#define DRV_EN PA2
#define NOP()       __Asm nop
#define CLRWDT()    __Asm CWDT
#define DI()        INTG &=0X7F;          //GIE_GIEH=0; PEIE_GIEL=0;
#define EI()        INTG |=0X80;          //GIE_GIEH=1; PEIE_GIEL=0;
#define SUCCESS 1
#define FALSE 0
#define GETSPEED 0
#define START_TIME 500

typedef enum 
{
	MOTOR_START = 0,
	MOTOR_RUN = 1,
	MOTOR_STOP = 2,
	MOTOR_CHANGEDIR = 3,
	MOTOR_VPROTECT = 4,
	MOTOR_IPROTECT =5,
}run_state;

void gpio_init(void);
uint8  startMotor(void);

void change_step_I(void);
void change_step(void);
float get_speed(void);