#include "PID.h"




void PID_init()
{
    pid.SetSpeed=0.0;
    pid.ActualSpeed=0.0;
	pid.last_speed = 0.0;
	pid.perr =0.0;
    pid.err=0.0;
	pid.last_error = 0.0;
    pid.Kp=1.0;
    pid.Ki=0.1;

}

float PID_realize(float speed_reference,float speed_feedback)
{
    pid.SetSpeed=speed_reference;
	pid.ActualSpeed = speed_feedback;
    pid.err=pid.SetSpeed-pid.ActualSpeed;
	pid.perr = pid.err-pid.last_error;
	pid.Inc_voltage = pid.Kp * pid.perr+pid.Ki*pid.err;
	pid.last_error = pid.err;
	return pid.Inc_voltage;
}

