#include "adc.h"



/*********************************************************
: ADCInit
  : ADCܳʼ
ֵ: 
ֵ: 
ֵ: 
**********************************************************/
void ADCInit(void)
{
	ADC_InitStruType x;
	GPIO_InitSettingType y;
	
	y.Signal = GPIO_Pin_Signal_Analog;
	GPIO_Init(GPIO_Pin_B13,&y);

	x.CLKS = ADC_CLKS_PCLK;
	x.CLKDIV = ADC_CLKDIV_1_1;
	x.VREF_SEL = ADC_VREF_SEL_1_8;
	x.VREFP = ADC_VREFP_VDD;
	x.VREFN= ADC_VREFN_VSS;
	x.CHS = ADC_CHS_AIN5;
	x.SMPS = ADC_SMPS_HARD;
	x.ST = 8;
	x.VDD5_EN = ENABLE;

	ADC_Init(&x);
}

/*********************************************************
: ADCRead
  : ADCݶȡ(16βƽֵ)
ֵ: 
ֵ: 
ֵ: ƽֵ
**********************************************************/
uint16_t ADCRead(void)
{
	uint8_t i;
	uint32_t max, min, sum, ad_temp;

	max = 0x0;
	min = 0x0fff;
	sum = 0x0;  
	for (i=0; i<18; i++)
	{
		ADC_Start();            
		while(ADC_GetIFStatus(ADC_IF)==RESET);
		ad_temp = ADC_GetConvValue();  
		ADC_ClearIFStatus(ADC_IF); 
		if (ad_temp > max)
		{
			max = ad_temp;        
		}
		if (ad_temp < min)
		{
			min = ad_temp;        
		}
		sum += ad_temp;
	}
	sum -= min;
	sum -= max;
	return sum >>4;        
}
