#include "uart.h"

/*********************************************************
: void UARTInit(void)
  : UARTʼӳ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void UARTInit(void)
{
	GPIO_InitSettingType x;
	UART_InitStruType y;
	
	x.Signal = GPIO_Pin_Signal_Digital;
	x.Func = GPIO_Reuse_Func3;
	x.Dir  = GPIO_Direction_Output;
	x.ODE  = GPIO_ODE_Output_Disable;
	x.DS   = GPIO_DS_Output_Strong;
	x.PDE = GPIO_PDE_Input_Disable;
	x.PUE = GPIO_PUE_Input_Disable;
	
	GPIO_Init(GPIO_Pin_A31, &x);		//TXD - PA31
	
	x.Signal = GPIO_Pin_Signal_Digital;
	x.Func = GPIO_Reuse_Func3;
	x.Dir  = GPIO_Direction_Input;
	x.PUE = GPIO_PUE_Input_Disable;
	x.PDE = GPIO_PDE_Input_Disable;
	GPIO_Init(GPIO_Pin_A30, &x);		//RXD - PA30

	y.UART_BaudRate = 9600;				//
	y.UART_ClockSet = UART_Clock_1;		//ʱѡPclk
	y.UART_RxMode = UART_DataMode_8;	//ݸʽ8λ
	y.UART_RxPolar = UART_Polar_Normal;	//ն˿ڼԣ
	y.UART_StopBits = UART_StopBits_1;	//ֹͣλ1
	y.UART_TxMode = UART_DataMode_8;	//ݸʽ8λ
	y.UART_TxPolar = UART_Polar_Normal;	//Ͷ˿ڼԣ

	UART_Init(UART1, &y);
    
	UART_TBIMConfig(UART1, UART_TBIM_Byte);
	UART_RBIMConfig(UART1, UART_TBIM_Byte);
	UART_ITConfig(UART1, UART_IT_RB, Enable);
	NVIC_Init(NVIC_UART1_IRQn, NVIC_Priority_1, Enable);

	UART1_TxEnable();
	UART1_RxEnable();
}





