#include "main.h"

extern uchar motor_state;
float speed_value;
extern unsigned int speed_target;
extern uchar PID_flag=0;

float PID_err=0;
float PID_last_err =0;
float PID_kp = 0.01;
float PID_ki = 0.01;
float PID_pwm =0;
extern uint counter_1s;
unsigned int adc_value =0;
unsigned char LVDT_counter =0;
unsigned int run_counter = 0;
void main() 
{
	GIE = 1;
	gpio_init();
	cap_init();
	t11_init(); 
	UARTInit();
	TIM13_init();
	ADCInit();
	//startMotor();
	while(1)
	{
	/**************************Ƿѹ***************************/
		adc_value = ADCRead(12);  
		if(adc_value < LVDT_VALUE)
		{
			LVDT_counter++;
			if(LVDT_counter>=10)
			{
				LVDT_counter=10;
				motor_state = MOTOR_VPROTECT;
			}
		}
		else
		{
			LVDT_counter = 0;
			if(motor_state == MOTOR_VPROTECT )
				motor_state = MOTOR_STOP;
		}

		/**************************ٶ״̬UART***************************/
		speed_value = get_speed();
		if(counter_1s>=1000) //ÿ뷢һٶϢ
		{
			counter_1s == 0;
			uart_sendInit(speed_value);
		}

		/**************************״̬***************************/
		if(motor_state ==MOTOR_RUN )
		{
			run_counter++;
			if(run_counter>1000)
			{
				run_counter = 1000;
				KMSK0=1;  //KINT0
			}
		}
		else 
		{
			run_counter =0;
			KMSK0=0;  //KINT0
		}
		if(motor_state == MOTOR_START )
		{
			startMotor();
		}
		else if(motor_state ==MOTOR_STOP )
			stopMotor();
		else if(motor_state ==MOTOR_RUN )
		{
		
			if(PID_flag)
			{
				PID_flag =0;

				PID_err =speed_target - speed_value;
				PID_pwm =PID_pwm+PID_err*PID_kp+PID_ki*(PID_err-PID_last_err);			
				if(PID_pwm<=50)
					PID_pwm = 50;
				else if(PID_pwm>=990)
					PID_pwm =990;
				PID_last_err = PID_err;
				set_PWM_Duty((uint)PID_pwm);
			}
		}
		else if(motor_state ==MOTOR_CHANGEDIR)
		{
			stopMotor();
			delay(1000);
			startMotor();
		}
		else if(motor_state == MOTOR_VPROTECT)
		{
			stopMotor();
		}
		else if(motor_state == MOTOR_IPROTECT)
		{
			stopMotor();
		}
	}
}

void delay(unsigned int t)
{
	int i,j;
	for(i=0;i<t;i++)
		for(j=0;j<=100;j++)
		{
		}
}








